'
' RETROGRA Demo
'
' demonstrates the RETROGRA console, colour palette and mouse pointers
'

#INCLUDE "fbgfx.bi"
#INCLUDE "retrogra.bi"
#INCLUDE "utf8.bi"

DIM AS STRING key, schar
DIM AS INTEGER mx, my, b, i
DIM AS DOUBLE oclock

rgSCREENNEW

rgSHIFTPALETTE(-100,-100,-100) ' black the screen

' drawing demo graphics

' "CASTLE"
schar=UTF8(&H2B2E) ' big ellipse form
rgPRINT PRINTCOLOR(215,206) ' white+sky
rgPRINT STRING(80," ")
rgPRINT STRING(80," ")
rgPRINT STRING(28," ")
rgPRINT schar+schar+schar+" "+schar+schar+schar+" "+schar+schar+schar+" "+schar+schar+schar+" "+schar+"   "+schar+schar+schar
rgPRINT STRING(57," ")
rgPRINT schar+"   "+schar+" "+schar+" "+schar+"    "+schar+"  "+schar+"   "+schar+"  "
rgPRINT STRING(57," ")
rgPRINT schar+"   "+schar+schar+schar+" "+schar+schar+schar+"  "+schar+"  "+schar+"   "+schar+schar+" "
rgPRINT STRING(57," ")
rgPRINT PRINTCOLOR(172,206) ' fair grey+sky
rgPRINT schar+"   "+schar+" "+schar+"   "+schar+"  "+schar+"  "+schar+"   "+schar+"  "
rgPRINT STRING(57," ")
rgPRINT PRINTCOLOR(129,206) ' grey+sky
rgPRINT schar+schar+schar+" "+schar+" "+schar+" "+schar+schar+schar+"  "+schar+"  "+schar+schar+schar+" "+schar+schar+schar
rgPRINT STRING(29," ")
rgPRINT STRING(80," ") ' space line

' "ADVENTURE"
rgPRINT PRINTCOLOR(215,206) ' white+sky
rgPRINT STRING(22," ")
rgPRINT schar+schar+schar+" "+schar+schar+"  "+schar+" "+schar+" "+schar+schar+schar+" "+schar+"  "+schar+" "
rgPRINT schar+schar+schar+" "+schar+" "+schar+" "+schar+schar+"  "+schar+schar+schar
rgPRINT STRING(44," ")
rgPRINT schar+" "+schar+" "+schar+" "+schar+" "+schar+" "+schar+" "+schar+"   "+schar+schar+" "+schar+" "
rgPRINT " "+schar+"  "+schar+" "+schar+" "+schar+" "+schar+" "+schar+"  "
rgPRINT STRING(44," ")
rgPRINT schar+schar+schar+" "+schar+" "+schar+" "+schar+" "+schar+" "+schar+schar+schar+" "+schar+schar+schar+schar+" "
rgPRINT " "+schar+"  "+schar+" "+schar+" "+schar+schar+"  "+schar+schar+schar
rgPRINT STRING(44," ")
rgPRINT PRINTCOLOR(172,206) ' fair grey+sky
rgPRINT schar+" "+schar+" "+schar+" "+schar+" "+schar+" "+schar+" "+schar+"   "+schar+" "+schar+schar+" "
rgPRINT " "+schar+"  "+schar+" "+schar+" "+schar+" "+schar+" "+schar+"  "
rgPRINT STRING(44," ")
rgPRINT PRINTCOLOR(129,206) ' grey+sky
rgPRINT schar+" "+schar+" "+schar+schar+"   "+schar+"  "+schar+schar+schar+" "+schar+"  "+schar+" "
rgPRINT " "+schar+"  "+schar+schar+schar+" "+schar+" "+schar+" "+schar+schar+schar
rgPRINT STRING(22," ")
rgPRINT STRING(80," ") ' space line

' castle painting
rgPRINT STRING(20," ")
rgPRINT PRINTCOLOR(129,206) ' grey+sky
' tower battlements
rgPRINT CHR(27,65,26)+"1"+CHR(27,97)+" "+CHR(27,65,26,49,27,97,32)+CHR(27,65,26,49,27,97,32)+CHR(27,65,26,49,27,97)
rgPRINT STRING(27," ")
rgPRINT CHR(27,65,26,49,27,97,32)+CHR(27,65,26,49,27,97,32)+CHR(27,65,26,49,27,97,32)+CHR(27,65,26,49,27,97)
rgPRINT STRING(19," ")
rgPRINT STRING(20," ")
rgPRINT PRINTCOLOR(129,172) ' grey on fair grey
rgPRINT UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)
rgPRINT PRINTCOLOR(129,206) ' grey+sky
rgPRINT STRING(27," ")
rgPRINT PRINTCOLOR(129,172) ' grey on fair grey
rgPRINT UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)
rgPRINT PRINTCOLOR(129,206) ' grey+sky
rgPRINT STRING(40," ")
rgPRINT PRINTCOLOR(129,172) ' grey on fair grey
rgPRINT UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)
rgPRINT PRINTCOLOR(129,206) ' grey+sky
rgPRINT STRING(29," ")
rgPRINT PRINTCOLOR(129,172) ' grey on fair grey
rgPRINT UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)
rgPRINT PRINTCOLOR(129,206) ' grey+sky
rgPRINT STRING(41," ")
rgPRINT PRINTCOLOR(129,172) ' grey on fair grey
rgPRINT UTF8(&H2593)+UTF8(&H2593)
rgPRINT PRINTCOLOR(129,240)+" "+PRINTCOLOR(129,172) ' (grey+)black /-> grey on fair grey 
rgPRINT UTF8(&H2593)+UTF8(&H2593)
rgPRINT PRINTCOLOR(129,206) ' grey+sky
rgPRINT STRING(29," ")
rgPRINT PRINTCOLOR(129,172) ' grey on fair grey
rgPRINT UTF8(&H2593)+UTF8(&H2593)
rgPRINT PRINTCOLOR(129,240)+" "+PRINTCOLOR(129,172) ' (grey+)black /-> grey on fair grey 
rgPRINT UTF8(&H2593)+UTF8(&H2593)
rgPRINT PRINTCOLOR(129,206) ' grey+sky
rgPRINT STRING(41," ")
rgPRINT PRINTCOLOR(129,172) ' grey on fair grey
rgPRINT UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)
rgPRINT PRINTCOLOR(129,206) ' grey+sky
rgPRINT STRING(29," ")
rgPRINT PRINTCOLOR(129,172) ' grey on fair grey
rgPRINT UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)
rgPRINT PRINTCOLOR(129,206) ' grey+sky
rgPRINT STRING(41," ")
rgPRINT PRINTCOLOR(129,172) ' grey on fair grey
rgPRINT UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)
' wall battlements
rgPRINT PRINTCOLOR(129,206) ' grey+sky
rgPRINT CHR(27,65,26,49,26,49,27,97,32)+CHR(27,65,26,49,26,49,26,49,27,97,32)+CHR(27,65,26,49,26,49,26,49,27,97,32)+CHR(27,65,26,49,26,49,26,49,27,97,32)
rgPRINT CHR(27,65,26,49,26,49,26,49,27,97,32)+CHR(27,65,26,49,26,49,26,49,27,97,32)+CHR(27,65,26,49,26,49,26,49,27,97,32)+CHR(27,65,26,49,26,49,27,97)
rgPRINT PRINTCOLOR(129,172) ' grey on fair grey
rgPRINT UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)
rgPRINT PRINTCOLOR(129,206) ' grey+sky
rgPRINT STRING(41," ")
' wall
rgPRINT PRINTCOLOR(129,172) ' grey on fair grey
rgPRINT UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)
rgPRINT UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)
rgPRINT UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)
rgPRINT UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)
rgPRINT PRINTCOLOR(129,206) ' grey+sky
rgPRINT STRING(41," ")
rgPRINT PRINTCOLOR(129,172) ' grey on fair grey
rgPRINT UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)
rgPRINT UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)
rgPRINT UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)
rgPRINT UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)
rgPRINT PRINTCOLOR(129,206) ' grey+sky
rgPRINT STRING(41," ")
' gate
rgPRINT PRINTCOLOR(129,172) ' grey on fair grey
rgPRINT UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)
rgPRINT UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)
rgPRINT PRINTCOLOR(15,240) ' brown on black
rgPRINT UTF8(&H254B)+UTF8(&H254B)+UTF8(&H254B)+UTF8(&H254B)+UTF8(&H254B)
rgPRINT PRINTCOLOR(129,172) ' grey on fair grey
rgPRINT UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)
rgPRINT UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)
rgPRINT PRINTCOLOR(129,206) ' grey+sky
rgPRINT STRING(41," ")
rgPRINT PRINTCOLOR(129,172) ' grey on fair grey
rgPRINT UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)
rgPRINT UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)
rgPRINT PRINTCOLOR(15,240) ' brown on black
rgPRINT UTF8(&H254B)+UTF8(&H254B)+UTF8(&H254B)+UTF8(&H254B)+UTF8(&H254B)+UTF8(&H254B)+UTF8(&H254B)
rgPRINT PRINTCOLOR(129,172) ' grey on fair grey
rgPRINT UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)
rgPRINT UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)
rgPRINT PRINTCOLOR(129,206) ' grey+sky
rgPRINT STRING(41," ")
rgPRINT PRINTCOLOR(129,172) ' grey on fair grey
rgPRINT UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)
rgPRINT UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)
rgPRINT PRINTCOLOR(15,240) ' brown on black
rgPRINT UTF8(&H254B)+UTF8(&H254B)+UTF8(&H254B)+UTF8(&H254B)+UTF8(&H254B)+UTF8(&H254B)+UTF8(&H254B)
rgPRINT PRINTCOLOR(129,172) ' grey on fair grey
rgPRINT UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)
rgPRINT UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)
rgPRINT PRINTCOLOR(129,206) ' grey+sky
rgPRINT STRING(41," ")
rgPRINT PRINTCOLOR(129,172) ' grey on fair grey
rgPRINT UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)
rgPRINT UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)
rgPRINT PRINTCOLOR(15,240) ' brown on black
rgPRINT UTF8(&H254B)+UTF8(&H254B)+UTF8(&H254B)+UTF8(&H254B)+UTF8(&H254B)+UTF8(&H254B)+UTF8(&H254B)
rgPRINT PRINTCOLOR(129,172) ' grey on fair grey
rgPRINT UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)
rgPRINT UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)+UTF8(&H2593)
rgPRINT PRINTCOLOR(129,206) ' grey+sky
rgPRINT STRING(20," ")
' grass
rgPRINT PRINTCOLOR(18,24) ' green on fair green
rgPRINT UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)
rgPRINT UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)
rgPRINT UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)
rgPRINT UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)
rgPRINT UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)
rgPRINT UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)
rgPRINT UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)
rgPRINT UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)
'
rgPRINT UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)
rgPRINT UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)
rgPRINT UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)
rgPRINT UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)
rgPRINT UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)
rgPRINT UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)
rgPRINT UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)
rgPRINT UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)+UTF8(&H2591)

' spectrum bar
rgPRINT PRINTCOLOR(215,240) ' white on black
rgPRINT STRING(80," ")

rgPRINT STRING(9," ")
rgPRINT PRINTCOLOR(240,5)+"  "+PRINTCOLOR(240,11)+"  "+PRINTCOLOR(240,17)+"  "+PRINTCOLOR(240,23)+"  "+PRINTCOLOR(240,29)+"  "+PRINTCOLOR(240,35)+"  "
rgPRINT PRINTCOLOR(240,34)+"  "+PRINTCOLOR(240,33)+"  "+PRINTCOLOR(240,32)+"  "+PRINTCOLOR(240,31)+"  "+PRINTCOLOR(240,30)+"  "
rgPRINT PRINTCOLOR(240,66)+"  "+PRINTCOLOR(240,102)+"  "+PRINTCOLOR(240,138)+"  "+PRINTCOLOR(240,174)+"  "+PRINTCOLOR(240,210)+"  "
rgPRINT PRINTCOLOR(240,204)+"  "+PRINTCOLOR(240,198)+"  "+PRINTCOLOR(240,192)+"  "+PRINTCOLOR(240,186)+"  "+PRINTCOLOR(240,180)+"  "
rgPRINT PRINTCOLOR(240,181)+"  "+PRINTCOLOR(240,182)+"  "+PRINTCOLOR(240,183)+"  "+PRINTCOLOR(240,184)+"  "+PRINTCOLOR(240,185)+"  "
rgPRINT PRINTCOLOR(240,149)+"  "+PRINTCOLOR(240,113)+"  "+PRINTCOLOR(240,77)+"  "+PRINTCOLOR(240,41)+"  "+PRINTCOLOR(240,5)+"  "
rgPRINT PRINTCOLOR(215,240)+STRING(9," ")

' fade in
FOR i=-100 TO 0 STEP 5
  rgSHIFTPALETTE(i, i, i)
  RGSCREENSHOW ' shows mouse pointer
  SLEEP 25
NEXT

' MAIN (loop)
i=1
oclock=TIMER
DO
  key=INKEY
  rgGETMOUSE (mx,my,,b)
  IF b=1 AND (TIMER-oclock)>0.25 THEN
    i+=1
    IF i>10 THEN i=1
    rgSETMOUSE i
    oclock=timer
  ENDIF
  SLEEP 10
  rgSCREENSHOW
LOOP WHILE key="" AND b<>2
rgSCREENDELETE
